// Read in the Les Miserables JSON file and make a 
// force directed graph of the data.

JSONObject data;               // Variable to read in data from JSON file
PFont   font_arial;            // Arial font
ForceDirectedGraph myFDG = new ForceDirectedGraph();

boolean first_run = true;
boolean mouseOver;             // Flag to check if mouse is over some data point

void setup() {
  size(800, 800);
  //frameRate(30);
  font_arial = createFont("Arial", 16);
  data = loadJSONObject("miserables.json");  // read in the JSON file
}


void draw() {
  background(255);
  
  if (data == null){
    // no file selected yet
  }
  else{
    if(first_run)  init();
    first_run = false;
    
    // Draw all the plots
    myFDG.draw();
  }
  
  // Print the instructions
  String inst = "Try dragging the nodes around.";
  textFont(font_arial, 12);        
  textAlign(LEFT);
  fill(0);
  text(inst, 200, 20);
}


// Initialization
void init() {
  // Set the properties of the ForceDirectedGraph
  myFDG.setFigSize(800, 800);
  myFDG.setNodeMass(5);
  myFDG.setNodeSize(11);
  myFDG.setNodeFillColor(color(214, 39, 40));
  myFDG.setNodeStrokeColor(color(255));
  myFDG.setLinkWidth(1);
  myFDG.setLinkStrokeColor(color(153));
  myFDG.setTimeStep(0.3);
  myFDG.setRepulsionConstant(120);
  myFDG.setAttractionConstant(0.1);
  myFDG.setSpringRestLength(10);
  myFDG.setDampingCoefficient(0.9);
  
  myFDG.setData(data);
}


// Check for mouse events
void mousePressed() {
  myFDG.mouseWasPressed(mouseX, mouseY);
}

void mouseDragged() {
  myFDG.mouseWasDragged(mouseX, mouseY);
}

void mouseReleased() {
  myFDG.mouseWasReleased();
}